#include <compat.h>
#include <via.h>

#ifdef USE_VSYNC
#ifdef USE_VSYNC_SOFT

#ifdef USE_VSYNC_AUTO_TEXT
#define A_50HZ      A_TEXT50
#define A_60HZ      A_TEXT60
#define line_adr(x) $bb80+(5*x)
#else
#define A_50HZ      A_HIRES50
#define A_60HZ      A_HIRES60
#define line_adr(x) $a000+(40*x)
#endif

_vsync_auto
    ;
    php
    sei
    tya
    pha

    ; start T1 with 50Hz period
    lda _isr_period
    sta via_t1cl
    lda _isr_period+1
    sta via_t1ch

    ; establish 50Hz graphics mode
    lda #A_50HZ
    sta line_adr(0)

    ; wait at least a frame
.(
    ldx #4
    lda #via_irq_t1
wait
    bit via_ifr
    beq wait
    bit via_t1cl
    dex
    bne wait
.)

    ; write 60Hz to line address 0, wait 7168 cycles (112 lines)
__1
.(
    lda #A_60HZ
    sta line_adr(0)

    ldy #5
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #146
wait_xx
    dex
    bne wait_xx
.)
__11


    ; write 50Hz to line address 0, wait 16896 cycles (264 lines)
__2
.(
    lda #A_50HZ
    sta line_adr(0)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__21


    ; write 60Hz to line address 0, wait 7168 cycles (112 lines)
__3
.(
    lda #A_60HZ
    sta line_adr(0)

    ldy #5
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #146
wait_xx
    dex
    bne wait_xx
.)
__31


    ; write 50Hz to line address 0, wait 16896 cycles (264 lines)
__4
.(
    lda #A_50HZ
    sta line_adr(0)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__41

    ; (you have now eliminated lines 200..311 as possibilities, pushing anyone that was there into 0..111)

    ; write 60Hz to line address 48, wait 3072 cycles (48 lines)
__5
.(
    lda #A_60HZ
    sta line_adr(48)

    ldy #2
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #98
wait_xx
    dex
    bne wait_xx
    nop
.)
__51


    ; write 50Hz to line address 48, wait 16896 cycles (264 lines)
__6
.(
    lda #A_50HZ
    sta line_adr(48)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__61

    ; (you have now also eliminated lines 0..47 as possibilities)

    ; write 60Hz to line address 96, wait 3072 cycles (48 lines)
__7
.(
    lda #A_60HZ
    sta line_adr(96)

    ldy #2
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #98
wait_xx
    dex
    bne wait_xx
    nop
.)
__71

    ; write 50Hz to line address 96, wait 16896 cycles (264 lines)
__8
.(
    lda #A_50HZ
    sta line_adr(96)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__81


    ; (you have now also eliminated lines 48..95 as possibilities)

    ; write 60Hz to line address 144, wait 3072 cycles (48 lines)
__9
.(
    lda #A_60HZ
    sta line_adr(144)

    ldy #2
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #98
wait_xx
    dex
    bne wait_xx
    nop
.)
__91


    ; write 50Hz to line address 144, wait 16896 cycles (264 lines)
__A
.(
    lda #A_50HZ
    sta line_adr(144)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__A1


    ; (you have now also eliminated lines 96..143 as possibilities, put potentially repopulated the range 200..207 (?))

    ; write 60Hz to line address 200, wait 3072 cycles (48 lines)
__B
.(
    lda #A_60HZ
    sta line_adr(200)

    ldy #2
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #98
wait_xx
    dex
    bne wait_xx
    nop
.)
__B1


    ; write 50Hz to line address 200, wait 16896 cycles (264 lines)
__C
.(
    lda #A_50HZ
    sta line_adr(200)

    ldy #13
wait_y
    ldx #0
wait_x
    dex
    bne wait_x
    dey
    bne wait_y

    ldx #34
wait_xx
    dex
    bne wait_xx
.)
__C1

    ; (you have now eliminated [pixel parts of] lines 144..199 as possibilities, but repopulated 208..251 (?))
    ; start a 19968 cycle period interrupt timer.
    lda _isr_period
    sta via_t1cl
    lda _isr_period+1
    sta via_t1ch

    pla
    tay
    plp
    rts

#else
_vsync_auto
    rts
#endif /* USE_VSYNC_SOFT */

#endif /* USE_VSYNC */
